from cherrypy import cpg
import os

from releases import Release

class Download:
    def default(self, *args, **kwargs ):
        # remap parameters to fix positional parameters
        if hasattr( self, args[ 0 ] ):
            return getattr( self, args[0])( *args[ 1: ], **kwargs )
    default.exposed = True
        
    def file2Generator(self, f):
        while 1:
            data = f.read(1024 * 8)
            if not data: break
            yield data

    def releases(self, pjid, file):
        path = "releases/%s/%s" % (pjid, file)
        rel = Release.selectBy(filename=file, projectID=pjid)
        if rel.count():
            rel[0].downloads += 1
        return self.download(path)
        
    def download(self, path):
        fStat = os.stat(path)
        cpg.response.headerMap["Content-Type"] = "application/x-download"
        cpg.response.headerMap['Content-Length'] = int(fStat.st_size)
        cpg.response.headerMap["Content-Disposition"] = "attachment; filename=%s" % (os.path.basename(path), )
        f = open(path, 'rb')
        return self.file2Generator(f)
    
