from cherrypy import cpg
from cherrytemplate import renderTemplate
from cherrypy.lib import httptools

from utils import *
import forms

class WebRoot:
    def __init__(self, *kwds):
        self.adm_form = forms.Form(name='birthday',
                            onExit = None,
                            fields = [forms.IntField('B', 'B:')],
                            submit = forms.SubmitField('next','Next: ',value='Go!'),
                            confirm = None)

    def render_page(self, cont_page):
        cont = renderTemplate(file="templates/%s.html"%cont_page)
        return self.render(cont)
    
    def render(self, cont):
        Top = renderTemplate(file="templates/top.html")
        Menu = renderTemplate(file="templates/menu.html")

        Content = cont

        
        Bottom = renderTemplate(file="templates/bottom.html")
        
        return renderTemplate(file="templates/skel.html")

    # Pages
    def index(self):
        from news import WebNews
        html = renderTemplate(file="templates/home.html")
        news = WebNews()
        html += news.list(embed=True, limit=3)
        
        return self.render(html)
    index.exposed = True

    def about(self):
        from admin import Admin
        admins = Admin.select()
        html = renderTemplate(file="templates/about.html")
        return self.render(html)
    about.exposed = True
    
if __name__ == "__main__":

    
    def start():
        import projects, admin, screenshot, releases, news, admin, repositories, patchbox, download
        
        try:
            projects.Project.createTable()
        except:
            pass

        try:
            screenshot.Screenshot.createTable()
        except:
            pass

        try:
            releases.Release.createTable()
        except:
            pass

        try:
            news.News.createTable()
        except:
            pass

        try:
            admin.Admin.createTable()
        except:
            pass

        try:
            repositories.Repository.createTable()
        except:
            pass


        try:
            patchbox.Patch.createTable()
        except:
            pass



    
        cpg.root = WebRoot()
        cpg.root.news = news.WebNews()
        cpg.root.projects = projects.WebProject()
        cpg.root.admin = admin.WebAdmin()
        cpg.root.patchbox = patchbox.WebPatchBox()
        cpg.root.developer = admin.WebAdmin()
        cpg.root.download = download.Download()

        cpg.server.start(configFile="config.cfg")
    
    import autoreload
    autoreload.main(start)
          
