from cherrypy import cpg
from cherrytemplate import renderTemplate
from cherrypy.lib.filter import basefilter
from fileuploadfilter import FileUploadFilter

from cherrypy.lib import httptools

import shutil, os

from sqlobject import *

from utils import *
from index import WebRoot

from connection import conn

class Patch(SQLObject):
    _connection = conn
    _defaultOrder="software"
    author = StringCol()
    software = StringCol()
    description = StringCol()
    filename = StringCol()


class WebPatchBox(WebRoot):
    UploadContext = [('add', 'filename', 'uploads/'),
                     ('edit', 'filename', 'uploads/')]
    _cpFilterList = [FileUploadFilter(UploadContext)]

    def index(self):
        return self.list()

    index.exposed = True

    def list(self):
        patches = Patch.select()
        html = renderTemplate(file="templates/patchbox_list.html")
        return self.render(html)

    list.exposed = True


    def add(self, author=None, software=None, description=None, filename=None):
        if author and software and description and filename and cpg.request.filenameMap["filename"] != "":

            shutil.move(filename, "patches/%s"%cpg.request.filenameMap["filename"])
            Patch(author=author,
                  software=software,
                  description=description,
                  filename=cpg.request.filenameMap["filename"])

            httptools.redirect("/patchbox")
        else:
            if filename and cpg.request.filenameMap["filename"] != "":
                os.unlink(cpg.request.filenameMap["filename"])
            
            return self.render_page("admin_patchbox_add")

    add = adminOnly(add)


    def delete(self, pid, confirmed=None):
        patch = Patch.get(pid)

        if confirmed:
            Patch.delete(pid)
            httptools.redirect("/patchbox")
        else:
            conf_msg="Do you really want to delete patch %s ?" % patch.software
            conf_yes="delete"
            conf_hidden = { "pid" : pid,
                            "confirmed" : "yes" }
            
            html = renderTemplate(file="templates/confirm_action.html")
            return self.render(html)

    delete = adminOnly(delete)


    def edit(self, pid, author=None, software=None, description=None, filename=None):
        patch = Patch.get(pid)

        if author and software and description:
            if cpg.request.filenameMap["filename"] != "":
                dstname = cpg.request.filenameMap["filename"]
                basepath = "patches/"
                oldpath = os.path.join(basepath, patch.filename)
                newpath = os.path.join(basepath, dstname)
                
                os.unlink(oldpath)
                shutil.move(filename, newpath)
                
                patch.filename = dstname
            elif filename != None:
                os.unlink(filename)

            patch.author = author
            patch.software = software
            patch.description = description
            
            httptools.redirect("/patchbox/")
        else:
            if filename != None:
                os.unlink(filename)
            html = renderTemplate(file="templates/admin_patch_edit.html")
            return self.render(html)

    edit = adminOnly(edit)

