from cherrypy import cpg
from cherrypy.lib.filter import basefilter
from cherrytemplate import renderTemplate
from fileuploadfilter import FileUploadFilter
from cherrypy.lib import httptools

import shutil, os
from datetime import datetime
from sqlobject import *

from index import WebRoot

from utils import *

from connection import *

class Repository(SQLObject):
    _connection = conn
    _defaultOrder="-id"
    project = ForeignKey("Project")
    distribution = StringCol()
    archs = StringCol()
    address = StringCol()

    

class WebRepositories(WebRoot):

    def add(self, pjid, distribution, archs, address):
        Repository(projectID=pjid,
                   distribution = distribution,
                   archs = archs,
                   address = address)

        return self.list(pjid)
        
    add = adminOnly(add)

    def edit(self, rid, distribution=None, archs=None, address=None):
        repository = Repository.get(rid)
        
        if distribution and archs and address:
            repository.distribution = distribution
            repository.archs = archs
            repository.address = address

            httptools.redirect("/projects/%s"%repository.project.name)
        else:
            html = renderTemplate(file="templates/admin_repositories_edit.html")
            return self.render(html)

    edit.exposed=True
    
    def delete(self, rid, ref=None):
        r = Repository.get(rid)

        Repository.delete(rid)

        if not ref:
            return self.list(r.projectID)
        else:
            httptools.redirect(ref)
        
    delete = adminOnly(delete)

    def list(self, pjid):
        Repositories = Repository.selectBy(projectID=pjid)
        html = renderTemplate(file="templates/repositories_list.html")
        return self.render(html)

    list = adminOnly(list)

